--[[

	EQDing: This mod will bring back that EverQuest nostalgia while you level for Cataclysm, by playing the classic EQ DIIIIIING! noise.

	Author: Uli of Twisting Nether
	Created: 2007-09-26 by Uli

	I realize this code is not exactly the most elegant -- I'm learning LUA and how to integrate other libraries such as ACE.  This is just a quick mod I put together to play the sound - there really isn't much to it!

]]

local MODNAME = "EQDing";
local VERSION = 1.0;
local VERSIONSTR = "1.0";
local DEBUG = false;




--------------------------------------------------------------------------------------------------
-- Event handlers
--------------------------------------------------------------------------------------------------

function EQDing_OnLoad(self)

	self:RegisterEvent("VARIABLES_LOADED"); -- this fires right after the mod is loaded
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA"); -- this fires upon login after all mods are loaded
	self:RegisterEvent("PLAYER_LEVEL_UP");
	
    -- Slash Commands
	SlashCmdList["EQDING"] = ProcessSlash;
	SLASH_EQDING1, SLASH_EQDING2 = "/eqding","/eqd";
end


function EQDing_OnEvent(self, event, ...)

	if (event == "VARIABLES_LOADED") then
		if (not EQDing) then
			EQDing_Debug("Intializing Settings");
			EQDing_InitSettings();
		end
		EQDing_CheckVersion();
	elseif (event == "PLAYER_LEVEL_UP") then
		if (EQDing.enabled) then
			EQDing_PlayDing();
		end
	end

end


function ProcessSlash(msg,editbox)
	if string.upper(msg) == "ON" then
		EQDing.enabled = true;
		print("EQDing noise WILL play when you level.  Use /eqding OFF to turn it off");
	elseif string.upper(msg) == "OFF" then
		EQDing.enabled = false;
		print("EQDing noise will NOT play when you level.  Use /eqding ON to turn it back on");
	elseif string.upper(msg) == "TOGGLE" then
		EQDing.enabled = not EQDing.enabled
		
		if EQDing.enabled then
			print("EQDing is now ON");
		else
			print("EQDing is now OFF");
		end
		print("Use /eqding ON|OFF|TOGGLE to toggle the EQ DING! noise on level up.");
	else
		if EQDing.enabled then
			print("EQDing is ON");
		else
			print("EQDing is OFF");
		end
		print("Use /eqding ON|OFF|TOGGLE to toggle the EQ DING! noise on level up.");
	end
end


--------------------------------------------------------------------------------------------------
-- Global functions
--------------------------------------------------------------------------------------------------

function EQDing_InitSettings()

	EQDing = {};
	EQDing.modname = MODNAME;
	EQDing.version = VERSION;
	EQDing.enabled = true;
end


function EQDing_PlayDing()	
	-- note: these functions do not throw an error if file doesn't exist
	PlaySoundFile("Interface\\Addons\\"..MODNAME.."\\ding.mp3");
end

function EQDing_CheckVersion()

	-- if changing versions, we'll initialize any potentially new settings since initial release
	if (EQDing.version < VERSION) then
		EQDing_Debug("EQDing.version < VERSION");
	end
end
	



--------------------------------------------------------------------------------------------------
-- Library functions
--------------------------------------------------------------------------------------------------

function EQDing_Debug(msg)

	if (DEBUG) then
		EQDing_ChatMessage(MODNAME .. "DEBUG: " .. msg);
	end	
	
end